#!/usr/bin/perl -w

my @langs = ('de','fr','es','cz','hu');
my @test_sets = ('newstest2009');

my $combinedJudgmentsFile = $ARGV[0];

print "\t";
print `cat $combinedJudgmentsFile | grep $langs[0]-en |  perl generate-table.perl | grep -v n/a | perl spearmans-rank.perl | head -2 | tail -1`;
foreach my $src_lang (@langs) {
    print "$src_lang-en (";
    my $numSystems = `cat $combinedJudgmentsFile | grep $src_lang-en |  perl generate-table.perl | grep -v n/a | wc -l`;
    $numSystems =~ s/\s//g;
    $numSystems = $numSystems -2;
    print "$numSystems systems)\t";
    $numMetrics = `cat $combinedJudgmentsFile | grep $src_lang-en |  perl generate-table.perl | head -2 | tail -1 | wc -w`;
    $numMetrics =~ s/\s//g;

    @rankedSystems = ();
    @rankedSystems = `cat $combinedJudgmentsFile | grep $src_lang-en | perl generate-table.perl | tail -$numSystems | sort -nr -k2 | cut -f1`;
    chomp(@rankedSystems);
    for($i = 2; $i < $numMetrics+2; $i++) {
	@otherRanks = ();
	@otherRanks = `cat $combinedJudgmentsFile | grep $src_lang-en | perl generate-table.perl | tail -$numSystems | sort -nr -k$i | cut -f1`;
	chomp(@otherRanks);
	$otherRanks[0] = $rankedSystems[1];
	$otherRanks[1] = $rankedSystems[0];

	$numChnages = levenshtein(\@rankedSystems, \@otherRanks);
	print "$numChnages/" . @rankedSystems .  "\t";
    }
    print "\n";

}

@langs = ('de','fr','es','cz');
print "\n\n\t";
print `cat $combinedJudgmentsFile | grep en-$langs[0] |  perl generate-table.perl | grep -v n/a | perl spearmans-rank.perl | head -2 | tail -1`;
foreach my $src_lang (@langs) {
    print "en-$src_lang (";
    my $numSystems = `cat $combinedJudgmentsFile | grep en-$src_lang |  perl generate-table.perl | grep -v n/a | wc -l`;
    $numSystems =~ s/\s//g;
    $numSystems= $numSystems -2;
    print "$numSystems systems)\t";



    $numMetrics = `cat $combinedJudgmentsFile | grep en-$src_lang |  perl generate-table.perl | head -2 | tail -1 | wc -w`;
    $numMetrics =~ s/\s//g;
    
    @rankedSystems = `cat $combinedJudgmentsFile | grep en-$src_lang | perl generate-table.perl | tail -$numSystems | sort -nr -k2 | cut -f1`;
    chomp @rankedSystems;
    for($i = 2; $i < $numMetrics+2; $i++) {
	@otherRanks = `cat $combinedJudgmentsFile | grep en-$src_lang | perl generate-table.perl | tail -$numSystems | sort -nr -k$i | cut -f1`;
	chomp @otherRanks;

	for($j = 0; $j < @rankedSystems; $j++) {
	    $rankHasChanged = 0;
	    if(!($rankedSystems[$j] eq $otherRanks[$j])) {
		print ($j+1);
		print "\t";
		$j=@rankedSystems;
		$rankHasChanged = 1;
	    }
	}
	if($rankHasChanged == 0) {
	    print "none\t";
	}

    }
    print "\n";

}




# Return the Levenshtein distance between two sequences of tags.
# Usage: levenshtein(\@rankedSystems, \@otherRanks)
#
sub levenshtein
{
    my $len1 = scalar(@rankedSystems);
    my $len2 = scalar(@otherRanks);

#    print "ccb - $len1 $len2\n";
#    foreach $item (@rankedSystems) {
#	print  $item . " "; 
#    }
#    print "\n";
#    foreach $item (@otherRanks) {
#	print  $item . " "; 
#    }
#    print "\n";



    # If either of the sequences is empty, then the distance is 1.0
    return 1.0 if ($len1 == 0);
    return 1.0 if ($len2 == 0);
    
    my %mat = ();
    # Initalize the distance matrix
    for (my $i = 0; $i <= $len1; ++$i)
    {
        for (my $j = 0; $j <= $len2; ++$j)
        {
            $mat{$i}{$j} = 0;
            $mat{0}{$j} = $j;
        }
        $mat{$i}{0} = $i;
    }


    for (my $i = 1; $i <= $len1; ++$i)
    {
        for (my $j = 1; $j <= $len2; ++$j)
        {
            # Denotes a substitution cost. When the tags are equal
            # there is no need to substitute, so the cost is 0
            #
            my $cost = ($rankedSystems[$i-1] eq $otherRanks[$j-1]) ? 0 : 1;

            # Cell $mat{$i}{$j} equals the minimum of:
            # - The cell immediately above plus 1
            # - The cell immediately to the left plus 1
            # - The cell diagonally above and to the left plus the cost
            #
            $mat{$i}{$j} = min([$mat{$i-1}{$j} + 1,
                                $mat{$i}{$j-1} + 1,
                                $mat{$i-1}{$j-1} + $cost]);
        }
    }

    # The Levenshtein distance is in the rightmost bottom cell
    my $maxLength = $len1;
    if($len2 > $maxLength) { $maxLength = $len2 };
    return $mat{$len1}{$len2};
}


# minimal element of a list
sub min
{
    my @list = @{$_[0]};
    my $min = $list[0];

    foreach my $i (@list)
    {
        $min = $i if ($i < $min);
    }

    return $min;
}
