#!/usr/bin/perl

# This creates a table out after running the command:
# cat all-system-level-ranks | grep "en-" | grep newstest | perl generate-table.perl | perl latex-it.perl

$isFirst = 1;




while($line = <>) {
    $line =~ s/_/-/g;
    if($isFirst == 1) {
	$task = $line;
	chomp $task;
	$label = $task;
	$label =~ s/\s+/-/g;
	$task =~ s/newstest2012/News Task/;

	
	$task =~ s/en/English/g;
	$task =~ s/fr/French/g;
	$task =~ s/de/German/g;
	$task =~ s/es/Spanish/g;
	$task =~ s/cz/Czech/g;
	$task =~ s/cs/Czech/g;
	$task =~ s/hu/Hungarian/g;
	$task =~ s/htclean/Haitian Creole (clean)/g;
	$task =~ s/htraw/Haitian Creole (raw)/g;

	$task =~ s/tSpanisht/test/g;
	$task =~ s/HCsyscombtest2011/Haitian Creole SMS Emergency Response Featured Translation Task/;

	
	$task =~ s/mEnglisht/ment/g;
	
	$header = <>;
	$header =~ s/_/-/g;
	@fields = split(/\t/, $header);
	
	
	# PRINT THE TABLE HEADER
	print "\\begin{table}\n";
	print "\\begin{center}\n";
	print "\\tiny\n";
	print "\\begin{tabular}{r";
	for($i = 1; $i < @fields; $i++) {
	    print "l";
	}
	print "}\n";
	for($i = 1; $i < @fields; $i++) {
	    $metric = $fields[$i];
	    print " &\t\\sysNameTop{$metric}";
	}
	print "\\\\ \n";
	$isFirst = 0;
	
	print "\\hline\n";
	print "\\multicolumn{" . scalar(@fields) .  "}{|c|}{$task}\\\\ \n";
	print "\\hline\n";
	
	$line = <>;
	$line =~ s/_/-/g;
    }
    @fields = split(/\t/, $line);
    $system = $fields[0];
    print "\\sysName{$system}";
    for($i = 1; $i < @fields; $i++) {
	$score = $fields[$i];
	$wins = 0;
	
	if($score =~ /\*/) {
	    $score =~ s/\*//g;
	    $wins = 1;
	}
	
	$isNegative = 0;
	if($score =~ /-\d/) {
	    $isNegative = 1;
	}


	if($score =~ /\d+\.\d\d\d/) {
	    $score =~ m/(\d+\.\d\d)(\d)/g;
	    $significantDigits = $1;
	    $roundingDigit = $2;
	    if($roundingDigit >= 5) {
		$significantDigits += 0.01;
	    }
	    $score  = $significantDigits;
	}

	if($score =~ /\d\d\.\d/) {
	    $score =~ m/(\d+)\.(\d)/g;
	    $significantDigits = $1;
	    $roundingDigit = $2;
	    if($roundingDigit >= 5) {
		$significantDigits += 1;
	    }
	    $score  = $significantDigits;
	}

	
	if($isNegative == 1) {
	    $score =~ s/-//g;
	    $score = "--" . $score; 
	}
	
	if($wins == 1) {
	    $score = "\\wins{$score}";
	}
	
	
	print " &\t$score";
	
    }
    print "\\\\\n";
    
}

# PRINT THE TABLE FOOTER
print "\\end{tabular}\n";
print "\\normalsize\n";
print "\\caption{Automatic evaluation metric scores for systems in the WMT12 $task}\\label{automatic-scores-$label}\n";
print "\\end{center}\n";
print "\\end{table}\n\n";

